
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define GPIO31 0x80000000
#define GPIO30 0x40000000
#define GPIO29 0x20000000
#define GPIO23 0x00800000
#define GPIO22 0x00400000
#define GPIO21 0x00200000
#define GPIO20 0x00100000

#define DEVNAME "/proc/gpio"

int main(int argc, char *argv[])
{
	FILE *dev;
	int d = 0;
	int n;
	char *ptr;
	char buf[256] = "";
	
	if((ptr = getenv("CONTENT_LENGTH")) != NULL)
	{
		n = fread(buf, 1, atoi(ptr), stdin);
		buf[n] = '\0';
	}
	if((dev = fopen(DEVNAME, "r+")) != NULL)
	{
		fscanf(dev, "%x", &d);
		if(strcmp(buf, "3=ON")  == 0) d |=  GPIO23;
		if(strcmp(buf, "3=OFF") == 0) d &= ~GPIO23;
		if(strcmp(buf, "2=ON")  == 0) d |=  GPIO22;
		if(strcmp(buf, "2=OFF") == 0) d &= ~GPIO22;
		if(strcmp(buf, "1=ON")  == 0) d |=  GPIO21;
		if(strcmp(buf, "1=OFF") == 0) d &= ~GPIO21;
		if(strcmp(buf, "0=ON")  == 0) d |=  GPIO20;
		if(strcmp(buf, "0=OFF") == 0) d &= ~GPIO20;
		fprintf(dev, "%x\n", d);
		fclose(dev);
	}

	printf("Content-type: text/html\n\n");
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\">");

	printf("<HTML>");

	printf("<HEAD>");
	printf("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=EUC-JP\">");
	printf("<TITLE>GPIO</TITLE>");
	printf("</HEAD>");

	printf("<BODY>");

	printf("<P STYLE=\"text-align: center; font-size: xx-large;\">GPIO</P>");
	printf("<HR>");

	printf("<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/gpio\">");

	printf("<TABLE BORDER=\"1\">");
	printf("<TR>");
	printf("<TD ALIGN=\"CENTER\">SW2</TD>");
	printf("<TD ALIGN=\"CENTER\">SW1</TD>");
	printf("<TD ALIGN=\"CENTER\">SW0</TD>");
	printf("<TD ALIGN=\"CENTER\">LED3</TD>");
	printf("<TD ALIGN=\"CENTER\">LED2</TD>");
	printf("<TD ALIGN=\"CENTER\">LED1</TD>");
	printf("<TD ALIGN=\"CENTER\">LED0</TD>");
	printf("</TR>");
	printf("<TR>");
	printf("<TD ALIGN=\"CENTER\">%s</TD>", d & GPIO31 ? "ON" : "OFF");
	printf("<TD ALIGN=\"CENTER\">%s</TD>", d & GPIO30 ? "ON" : "OFF");
	printf("<TD ALIGN=\"CENTER\">%s</TD>", d & GPIO29 ? "ON" : "OFF");
	printf("<TD ALIGN=\"CENTER\">%s</TD>", d & GPIO23 ? "ON" : "OFF");
	printf("<TD ALIGN=\"CENTER\">%s</TD>", d & GPIO22 ? "ON" : "OFF");
	printf("<TD ALIGN=\"CENTER\">%s</TD>", d & GPIO21 ? "ON" : "OFF");
	printf("<TD ALIGN=\"CENTER\">%s</TD>", d & GPIO20 ? "ON" : "OFF");
	printf("</TR>");
	printf("<TR>");
	printf("<TD ALIGN=\"CENTER\" COLSPAN=\"3\" ROWSPAN=\"2\"><INPUT TYPE=\"submit\" VALUE=\"READ\" NAME=\"READ\"></TD>");
	printf("<TD ALIGN=\"CENTER\"><INPUT TYPE=\"submit\" VALUE=\"ON\" NAME=\"3\"></TD>");
	printf("<TD ALIGN=\"CENTER\"><INPUT TYPE=\"submit\" VALUE=\"ON\" NAME=\"2\"></TD>");
	printf("<TD ALIGN=\"CENTER\"><INPUT TYPE=\"submit\" VALUE=\"ON\" NAME=\"1\"></TD>");
	printf("<TD ALIGN=\"CENTER\"><INPUT TYPE=\"submit\" VALUE=\"ON\" NAME=\"0\"></TD>");
	printf("</TR>");
	printf("<TR>");
	printf("<TD ALIGN=\"CENTER\"><INPUT TYPE=\"submit\" VALUE=\"OFF\" NAME=\"3\"></TD>");
	printf("<TD ALIGN=\"CENTER\"><INPUT TYPE=\"submit\" VALUE=\"OFF\" NAME=\"2\"></TD>");
	printf("<TD ALIGN=\"CENTER\"><INPUT TYPE=\"submit\" VALUE=\"OFF\" NAME=\"1\"></TD>");
	printf("<TD ALIGN=\"CENTER\"><INPUT TYPE=\"submit\" VALUE=\"OFF\" NAME=\"0\"></TD>");
	printf("</TR>");
	printf("</TABLE>");

	printf("</FROM>");

	printf("<HR>");

	printf("</BODY>");

	printf("</HTML>");
	
	return 0;
}
